MSKGraph Class Reference

the main class to read the text part of Claris Works file More...

`#include <MSKGraph.hxx>`

## Classes

struct | SendData

## Public Member Functions

| MSKGraph (MSKParser &parser)
| constructor More...
virtual | ~MSKGraph ()
| destructor More...
int | version () const
| returns the file version More...
int | numPages (int zoneId) const
| returns the number of pages More...
void | send (int id, MWAWPosition::AnchorTo anchor)
| send a zone (textbox, ...) More...
void | sendAll (int zoneId, bool mainZone)
| send all the picture corresponding to a zone More...
void | sendObjects (SendData const what)
| sends all the object of a page, frame, ... More...
void | computePositions (int zoneId, std::vector< int > &linesHeight, std::vector< int > &pagesHeight)
| try to update positions knowing pages and lines height More...

## Protected Member Functions

void | flushExtra ()
| sends the data which have not yet been sent to the listener More...
bool | readPictHeader (MSKGraphInternal::Zone &pict)
| read the picture header More...
int | getEntryPictureV1 (int zoneId, MWAWEntry &zone)
| checks if the next zone is a v1 picture and returns a zone id. More...
int | getEntryPicture (int zoneId, MWAWEntry &zone)
| checks if the next zone is a v2 picture and returns a zone id. More...
bool | readRB (MWAWInputStreamPtr input, MWAWEntry const &entry)
| reads the RBDR or a RBIL zone: a zone which seems to regroup all pages pictures More...
bool | readPictureV4 (MWAWInputStreamPtr input, MWAWEntry const &entry)
| reads a Pict zone: a zone which seems to code in v4 : header/footer picture More...
bool | readText (MSKGraphInternal::TextBox &textBox)
| try to read a text zone More...
void | sendTextBox (int id)
| send a textbox to the listener More...
void | checkTextBoxLinks (int zId)
| check the text box link More...
void | sendFrameText (MWAWEntry const &entry, std::string const &frame)
| ask m_mainParser to send a frame text(v4) More...
bool | readTable (MSKGraphInternal::Table &table)
| try to read a table zone More...
void | sendTable (int id)
| try to a table zone More...
bool | readChart (MSKGraphInternal::Zone &zone)
| try to read a chart (very incomplete) More...
shared_ptr < MSKGraphInternal::GroupZone > | readGroup (MSKGraphInternal::Zone &group)
| try to read the group data More...
bool | readFont (MSKGraphInternal::Font &font)
| reads the textbox font More...

## Protected Attributes

MWAWParserStatePtr | m_parserState
| the parser state More...
shared_ptr < MSKGraphInternal::State > | m_state
| the state More...
MSKParser * | m_mainParser
| the main parser; More...

## Private Member Functions

| MSKGraph (MSKGraph const &orig)
MSKGraph & | operator= (MSKGraph const &orig)

## Friends

class | MSK3Parser
class | MSK4Zone
class | MSKGraphInternal::SubDocument

## Detailed Description

the main class to read the text part of Claris Works file

## Constructor & Destructor Documentation

MSKGraph::MSKGraph | ( | MSKParser & | parser | ) |

constructor

MSKGraph::~MSKGraph | ( |  | ) |

virtual

destructor

MSKGraph::MSKGraph | ( | MSKGraph const & | orig | ) |

private

## Member Function Documentation

void MSKGraph::checkTextBoxLinks | ( | int | zId | ) |

protected

check the text box link

Referenced by readRB().

void MSKGraph::computePositions | ( | int | zoneId,
|  | std::vector< int > & | linesHeight,
|  | std::vector< int > & | pagesHeight
| ) |  |

try to update positions knowing pages and lines height

void MSKGraph::flushExtra | ( |  | ) |

protected

sends the data which have not yet been sent to the listener

int MSKGraph::getEntryPicture | ( | int | zoneId,
|  | MWAWEntry & | zone
| ) |  |

protected

checks if the next zone is a v2 picture and returns a zone id.

If not, returns -1.

Referenced by readChart(), readGroup(), and readRB().

int MSKGraph::getEntryPictureV1 | ( | int | zoneId,
|  | MWAWEntry & | zone
| ) |  |

protected

checks if the next zone is a v1 picture and returns a zone id.

If not, returns -1.

int MSKGraph::numPages | ( | int | zoneId | ) | const

returns the number of pages

MSKGraph& MSKGraph::operator= | ( | MSKGraph const & | orig | ) |

private

bool MSKGraph::readChart | ( | MSKGraphInternal::Zone & | zone | ) |

protected

try to read a chart (very incomplete)

Referenced by getEntryPicture().

bool MSKGraph::readFont | ( | MSKGraphInternal::Font & | font | ) |

protected

reads the textbox font

Referenced by readText().

shared_ptr< MSKGraphInternal::GroupZone > MSKGraph::readGroup | ( | MSKGraphInternal::Zone & | group | ) |

protected

try to read the group data

Referenced by getEntryPicture().

bool MSKGraph::readPictHeader | ( | MSKGraphInternal::Zone & | pict | ) |

protected

read the picture header

Referenced by getEntryPicture().

bool MSKGraph::readPictureV4 | ( | MWAWInputStreamPtr | input,
|  | MWAWEntry const & | entry
| ) |  |

protected

reads a Pict zone: a zone which seems to code in v4 : header/footer picture

bool MSKGraph::readRB | ( | MWAWInputStreamPtr | input,
|  | MWAWEntry const & | entry
| ) |  |

protected

reads the RBDR or a RBIL zone: a zone which seems to regroup all pages pictures

bool MSKGraph::readTable | ( | MSKGraphInternal::Table & | table | ) |

protected

try to read a table zone

Referenced by getEntryPicture().

bool MSKGraph::readText | ( | MSKGraphInternal::TextBox & | textBox | ) |

protected

try to read a text zone

Referenced by getEntryPicture().

void MSKGraph::send | ( | int | id,
|  | MWAWPosition::AnchorTo | anchor
| ) |  |

send a zone (textbox, ...)

Referenced by flushExtra(), sendAll(), and sendObjects().

void MSKGraph::sendAll | ( | int | zoneId,
|  | bool | mainZone
| ) |  |

send all the picture corresponding to a zone

void MSKGraph::sendFrameText | ( | MWAWEntry const & | entry,
|  | std::string const & | frame
| ) |  |

protected

ask m_mainParser to send a frame text(v4)

Referenced by MSKGraphInternal::SubDocument::parse().

void MSKGraph::sendObjects | ( | SendData const | what | ) |

sends all the object of a page, frame, ...

Referenced by MSKGraphInternal::SubDocument::parse().

void MSKGraph::sendTable | ( | int | id | ) |

protected

try to a table zone

Referenced by MSKGraphInternal::SubDocument::parse().

void MSKGraph::sendTextBox | ( | int | id | ) |

protected

send a textbox to the listener

Referenced by MSKGraphInternal::SubDocument::parse().

int MSKGraph::version | ( |  | ) | const

returns the file version

Referenced by getEntryPicture(), readChart(), readFont(), readGroup(), readPictHeader(), and readTable().

## Friends And Related Function Documentation

friend class MSK3Parser

friend

friend class MSK4Zone

friend

friend class MSKGraphInternal::SubDocument

friend

## Member Data Documentation

MSKParser* MSKGraph::m_mainParser

protected

the main parser;

Referenced by getEntryPicture(), getEntryPictureV1(), readChart(), readFont(), readGroup(), readPictHeader(), readPictureV4(), readRB(), readTable(), readText(), send(), sendFrameText(), and sendObjects().

MWAWParserStatePtr MSKGraph::m_parserState

protected

the parser state

Referenced by readTable(), readText(), send(), sendObjects(), sendTable(), sendTextBox(), and version().

shared_ptr<MSKGraphInternal::State> MSKGraph::m_state

protected

the state

Referenced by checkTextBoxLinks(), computePositions(), flushExtra(), getEntryPicture(), getEntryPictureV1(), numPages(), readChart(), readPictureV4(), readRB(), send(), sendAll(), sendObjects(), sendTable(), sendTextBox(), and version().

The documentation for this class was generated from the following files:

- MSKGraph.hxx
- MSKGraph.cxx